package ui;
import java.awt.List;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.RowFilter.Entry;
import org.apache.commons.net.ftp.*;
import org.apache.commons.io.*;


/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author Tony
 */
public class LoginFrame extends javax.swing.JFrame {

    LoginFrame mFrame;
    
    /**
     * Creates new form LoginFrame
     */
    public LoginFrame() throws IOException {
        initComponents();
        this.setLocationRelativeTo(null);
        mFrame = this;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jPasswordField1 = new javax.swing.JPasswordField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Login");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setLocation(new java.awt.Point(160, 120));
        setResizable(false);

        jLabel1.setText("Username:");

        jTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loginAction(evt);
            }
        });

        jLabel2.setText("Password:");

        jButton1.setText("Login");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loginAction(evt);
            }
        });

        jPasswordField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loginAction(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jButton1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jLabel2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTextField1)
                            .addComponent(jPasswordField1, javax.swing.GroupLayout.DEFAULT_SIZE, 236, Short.MAX_VALUE))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jPasswordField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void loginAction(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loginAction
        // TODO add your handling code here:
        jButton1.setEnabled(false);
        jTextField1.setEnabled(false);
        jPasswordField1.setEnabled(false);
        jButton1.setText("Logging in...");
        if(jTextField1.getText().isEmpty() == true){
            jButton1.setEnabled(true);
            jTextField1.setEnabled(true);
            jPasswordField1.setEnabled(true);
            jButton1.setText("Login");
            JOptionPane.showMessageDialog(mFrame, "Username cannot be empty.", "Error", JOptionPane.ERROR_MESSAGE);
            return;
        }
        new LoginThread().start();
    }//GEN-LAST:event_loginAction
    

    
    class LoginThread extends Thread {
        @Override
        public void run(){
            try {
                // TODO add your handling code here:
                String[][] data = new method.Http().connection("type=select&table=teachers&variables=id,password,name,subject");
                String usernameEntered = jTextField1.getText();
                String passwordEntered = new String(jPasswordField1.getPassword());
                boolean found = false;
                for (int i=0;i<data.length;i++){
                    if (usernameEntered.equals(data[i][0])){
                        if (passwordEntered.equals(data[i][1])){
                            System.out.println("Login successful");
                            String name = data[i][2];
                            String subject = data[i][3];
                            new MainFrame(name,subject).setVisible(true);
                            mFrame.setVisible(false);
                        }else{
                            JOptionPane.showMessageDialog(mFrame, "Password Incorrect! Please try again", "Error", JOptionPane.ERROR_MESSAGE);
                        }
                        found = true;
                        break;
                    }
                }
                if (!found){
                    JOptionPane.showMessageDialog(mFrame, "Username not found! Please try again", "Error", JOptionPane.ERROR_MESSAGE);
                }
                
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(mFrame, "Network error.", "Error", JOptionPane.ERROR_MESSAGE);
            }
            jButton1.setEnabled(true);
            jTextField1.setEnabled(true);
            jPasswordField1.setEnabled(true);
            jButton1.setText("Login");
        }
    }
   
    public static void main(String args[]) {

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                try {
                    new LoginFrame().setVisible(true);
                } catch (IOException ex) {
                    Logger.getLogger(LoginFrame.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPasswordField jPasswordField1;
    private javax.swing.JTextField jTextField1;
    // End of variables declaration//GEN-END:variables
}
